DATABASE leads
GLOBALS "globals.4gl"

FUNCTION contact()
{
The contact function uses the f_contact form to collect
information from the user.  It opens a series of windows
with forms to allow the user to make selections and enter
sales data.
}
DEFINE   pa_empnum            ARRAY[25] OF LIKE sperson.empnum,
         pa_spers             ARRAY[25] OF CHAR(31),
         pa_pcode             ARRAY[25] OF LIKE product.pcode,
         pa_desc              ARRAY[25] OF LIKE product.descrip,
         pcount, scount, cnt  SMALLINT,
         buf1, buf2           CHAR(15),
         msg1                 CHAR(59),
         msg2                 CHAR(52),
         msg3                 CHAR(53),
         msg4                 CHAR(39)

LET msg1 = "Use ARROW keys to move highlight, ESCAPE to make selection."
LET msg2 = "Enter 0 to display and choose from a list of values."
LET msg3 = "Enter C(complaint) I(request info) Q(inquiry) S(sale)"
LET msg4 = "Enter discount as a whole number 0 - 99"

DECLARE c_sperson CURSOR FOR
   SELECT      fname,
               lname,
               empnum
      FROM     sperson
      ORDER BY lname,
               fname

LET scount = 1
FOREACH c_sperson
   INTO   buf1,
          buf2,
          pa_empnum[scount]
   LET pa_spers[scount] = buf1 CLIPPED, 1 SPACE, buf2
   LET scount = scount + 1
END FOREACH

DECLARE c_prod CURSOR FOR
   SELECT      descrip,
               pcode
      FROM     product
      ORDER BY pcode

LET pcount = 1
FOREACH c_prod
   INTO   pa_desc[pcount],
          pa_pcode[pcount]
   LET pcount = pcount + 1
END FOREACH

INITIALIZE pr_contact.* TO NULL
LET pr_contact.cnum = 0
LET pr_contact.ref = pr_prospect.ref
OPEN FORM f_contact FROM "f_contact"
DISPLAY FORM f_contact

INPUT BY NAME  pr_contact.cdate THRU pr_contact.ctype

   AFTER FIELD cdate
      LET pr_contact.ndate = pr_contact.cdate + 14
      DISPLAY BY NAME pr_contact.ndate

   BEFORE FIELD empnum
      MESSAGE msg2 ATTRIBUTE(REVERSE)

   AFTER FIELD empnum
      LET eflag = -1
      IF (pr_contact.empnum IS NOT NULL
         AND pr_contact.empnum != 0) THEN
         SELECT      COUNT(*)
            INTO     cnt
            FROM     sperson
            WHERE    empnum = pr_contact.empnum
         IF (cnt != 1) THEN
            ERROR "There is no salesperson number ",
               pr_contact.empnum USING "###"
         ELSE
            LET eflag = 0
         END IF
      END IF
      IF (eflag < 0) THEN
         LET eflag = 0
         CALL SET_COUNT(scount - 1)
         OPEN WINDOW w_empnum AT 6,10 WITH FORM "f_empnum" ATTRIBUTE(BORDER)
         MESSAGE msg1 ATTRIBUTE(REVERSE)
         DISPLAY ARRAY pa_spers TO sr_con1.*
         CLOSE WINDOW w_empnum
         LET cnt = ARR_CURR()
         LET pr_contact.empnum = pa_empnum[cnt]
         DISPLAY BY NAME pr_contact.empnum
      END IF
      LET pr_contact.nemp = pr_contact.empnum
      DISPLAY BY NAME pr_contact.nemp

   BEFORE FIELD nemp
      MESSAGE msg2 ATTRIBUTE(REVERSE)

   AFTER FIELD nemp
      LET eflag = -1
      IF (pr_contact.nemp IS NOT NULL
         AND pr_contact.nemp != 0) THEN
         SELECT      COUNT(*)
            INTO     cnt
            FROM     sperson
            WHERE    empnum = pr_contact.nemp
         IF (cnt != 1) THEN
            ERROR "There is no salesperson number ",
               pr_contact.nemp USING "###"
         ELSE
            LET eflag = 0
         END IF
      END IF
      IF (eflag < 0) THEN
         LET eflag = 0
         CALL SET_COUNT(scount - 1)
         OPEN WINDOW w_empnum AT 6,10 WITH FORM "f_empnum" ATTRIBUTE(BORDER)
         MESSAGE msg1 ATTRIBUTE(REVERSE)
         DISPLAY ARRAY pa_spers TO sr_con1.*
         CLOSE WINDOW w_empnum
         LET cnt = ARR_CURR()
         LET pr_contact.nemp = pa_empnum[cnt]
         DISPLAY BY NAME pr_contact.nemp
      END IF

   BEFORE FIELD ctype
      MESSAGE msg3  ATTRIBUTE(REVERSE)

   AFTER FIELD ctype
      MESSAGE ""

END INPUT

IF (pr_contact.ctype = "S") THEN
   OPEN WINDOW w_sale AT 6,10
      WITH 9 ROWS, 55 COLUMNS
      ATTRIBUTE(BORDER)
   OPEN FORM f_sale FROM "f_sale"
   DISPLAY FORM f_sale
   INPUT BY NAME pr_sale.pcode THRU pr_sale.discount

   BEFORE FIELD pcode
      MESSAGE msg2 ATTRIBUTE(REVERSE)

   AFTER FIELD pcode
      MESSAGE ""
      LET eflag = -1
      IF (pr_sale.pcode IS NOT NULL
         AND pr_sale.pcode != "0") THEN
         SELECT      COUNT(*)
            INTO     cnt
            FROM     product
            WHERE    pcode = pr_sale.pcode
         IF (cnt != 1) THEN
            ERROR "There is no product code ", pr_sale.pcode USING "###"
         ELSE
            LET eflag = 0
         END IF
      END IF
      IF (eflag < 0) THEN
         LET eflag = 0
         CALL SET_COUNT(pcount - 1)
         OPEN WINDOW w_pdesc AT 9,17 WITH FORM "f_pdesc" ATTRIBUTE(BORDER)
         MESSAGE msg1 ATTRIBUTE(REVERSE)
         DISPLAY ARRAY pa_desc TO sr_con2.*
         CLOSE WINDOW w_pdesc
         LET cnt = ARR_CURR()
         LET pr_sale.pcode = pa_pcode[cnt]
         DISPLAY BY NAME pr_sale.pcode
      END IF

   BEFORE FIELD discount
      MESSAGE msg4 ATTRIBUTE(REVERSE)
      
   AFTER FIELD discount
      IF (pr_sale.discount < 0 OR pr_sale.discount > 100) THEN
         ERROR "Must be in the range 0-100"
         NEXT FIELD discount
      END IF

END INPUT
CLOSE WINDOW w_sale
END IF

INSERT INTO contact VALUES (pr_contact.*)
IF (pr_contact.ctype = "S") THEN
   LET pr_sale.cnum = SQLCA.SQLERRD[2]
   INSERT INTO sale VALUES (pr_sale.*)
END IF

CLEAR SCREEN
END FUNCTION
