DATABASE leads
REPORT r_label(rr)
{
The r_label report prints mailing labels for prospects. 
The output is sent to a file called label.out.
}

DEFINE   rr                RECORD LIKE prospect.*

OUTPUT
   REPORT TO "label.out"
   LEFT MARGIN 0
   TOP MARGIN 0
   BOTTOM MARGIN 0
   PAGE LENGTH 8  {change to the number of lines between the
                   top of one label and the top of the next}
FORMAT
ON EVERY ROW
   PRINT rr.title CLIPPED, 1 SPACE,
         rr.fname CLIPPED, 1 SPACE,
         rr.lname
   IF rr.company IS NOT NULL THEN PRINT rr.company END IF
   IF rr.add1 IS NOT NULL THEN PRINT rr.add1 END IF
   IF rr.add2 IS NOT NULL THEN PRINT rr.add2 END IF
   IF rr.add3 IS NOT NULL THEN PRINT rr.add3 END IF
   PRINT rr.city CLIPPED, ", ", rr.state, 2 SPACES, rr.zip
   SKIP TO TOP OF PAGE
END REPORT
