DATABASE leads
GLOBALS "globals.4gl"

MAIN
{
The s_contact program (a simplified version of the contact
function) displays the f_scontact form to collect information
from the user.  It opens a series of windows with forms to
allow the user to enter sales data and select a product code.
}
DEFINE   pa_pcode          ARRAY[25] OF LIKE product.pcode,
         pa_prod           ARRAY[25] OF LIKE product.descrip,
         cnt, pcount       SMALLINT

DECLARE c_prod CURSOR FOR
   SELECT      descrip,
               pcode
      FROM     product
      ORDER BY pcode

LET pcount = 1
FOREACH c_prod                      {Fill pa_prod array.}
   INTO   pa_prod[pcount],
          pa_pcode[pcount]
   LET pcount = pcount + 1
END FOREACH

INITIALIZE pr_contact.* TO NULL
LET pr_contact.cnum = 0
LET pr_contact.ref = 1     {Set to 1, no-error version only.}
OPEN FORM f_scontact FROM "f_scontact"
DISPLAY FORM f_scontact

INPUT BY NAME  pr_contact.cdate THRU pr_contact.ctype

   AFTER FIELD cdate
   {Set and display next contact 2 weeks from this contact.}
      LET pr_contact.ndate = pr_contact.cdate + 14
      DISPLAY BY NAME pr_contact.ndate

   AFTER FIELD empnum
   {Set and display next employee to current employee}
      LET pr_contact.nemp = pr_contact.empnum
      DISPLAY BY NAME pr_contact.nemp 

   BEFORE FIELD ctype
   {Display instructions for user.}
      MESSAGE "Enter C(complaint) I(request info) Q(inquiry) S(sale)"
         ATTRIBUTE(REVERSE)

   AFTER FIELD ctype
      MESSAGE ""                                   {Clear message line.       }

END INPUT

IF (pr_contact.ctype = "S") THEN
   OPEN WINDOW w_sale AT 6,10
      WITH 9 ROWS, 55 COLUMNS
      ATTRIBUTE(BORDER)
   OPEN FORM f_sale FROM "f_sale"
   DISPLAY FORM f_sale

   INPUT BY NAME  pr_sale.pcode THRU pr_sale.discount

   BEFORE FIELD pcode
   {Display instructions for user.}
      MESSAGE "Enter 0 to display and choose from a list of values."
         ATTRIBUTE(REVERSE)

   AFTER FIELD pcode
   {list products if user entered 0 or just pressed RETURN}
      MESSAGE ""                             {Clear message line.       }
      IF (pr_sale.pcode IS NULL              {See if user just pressed  }
         OR pr_sale.pcode = "0") THEN        {RETURN or entered 0.      }
         CALL SET_COUNT(pcount - 1)          {Set up for DISPLAY ARRAY. }
         OPEN WINDOW w_pdesc AT 9,17 WITH FORM "f_pdesc" ATTRIBUTE(BORDER)
         MESSAGE "Use ARROW keys to move highlight, ESCAPE to make selection."
            ATTRIBUTE(REVERSE)        {Display message in reverse video.}
         DISPLAY ARRAY pa_prod TO sr_con2.*  {Display array on form.    }
         CLOSE WINDOW w_pdesc
         LET cnt = ARR_CURR()         {Determine which item user picked.}
         LET pr_sale.pcode = pa_pcode[cnt] {record element=array element}
         DISPLAY BY NAME pr_sale.pcode       {Show product code on form.}
      END IF

   BEFORE FIELD discount
      MESSAGE "Enter discount as a whole number 0 - 99" ATTRIBUTE(REVERSE)

   AFTER FIELD discount
      MESSAGE ""
      
   END INPUT
CLOSE WINDOW w_sale
END IF

INSERT INTO contact VALUES (pr_contact.*) {Insert row into contact table.}
IF (pr_contact.ctype = "S") THEN          {If it was a sale,}
   LET pr_sale.cnum = SQLCA.SQLERRD[2]    {get serial number assigned by 4GL}
   INSERT INTO sale VALUES (pr_sale.*)    {insert row into sale table.}
END IF

END MAIN
